POJ 3126 - Prime Path

来源:互联网 发布:linux系统哪个好 编辑:程序博客网 时间:2024/05/13 07:21

F - Prime Path
Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%I64d & %I64u
Submit Status

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670


#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <queue>using namespace std;#define N 10005bool a[N];bool vis[N];void prime(){    memset(a,true,sizeof(a));    for (int i=2;i<N;i++)        if (a[i]){            for (int j=i+i;j<N;j+=i)                a[j]=false;        }    for (int i=0;i<1000;i++)        a[i]=false;}struct node{    int val,step;    node(int v,int s=0):val(v),step(s){}};int b[]={1,10,100,1000,10000};void bfs(){    int x,y;    scanf("%d%d",&x,&y);    queue<node> q;    memset(vis,false,sizeof(vis));    q.push(node(x,0));    vis[x]=true;    while (!q.empty()){        int val=q.front().val,step=q.front().step;        q.pop();        //cout<<val<<' '<<step<<endl;        if (val==y){            printf("%d\n",step);            return;        }        for (int i=0;i<4;i++){            int temp=val/b[i+1]*b[i+1]+val%b[i];            for (int j=0;j<10;j++){                if (j)                    temp+=b[i];                if (!vis[temp] && a[temp]){                    vis[temp]=true;                    q.push(node(temp,step+1));                }            }        }    }    printf("Impossible\n");}int main(){    prime();    int n;    scanf("%d",&n);    while(n--)        bfs();    return 0;}


0 0
原创粉丝点击